package squircle;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.logging.Level;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;
import javax.swing.JTextField;
import javax.swing.event.EventListenerList;

public class NumberField extends JTextField implements ActionListener,
		KeyListener, PropertyChangeListener, FocusListener {

	private String oldText = "";
	private boolean valid = true;
	private String defaulttext="";
    private ScriptEngine engine;
	private Number maxValue;
    private Number minValue;

//	public NumberField() {
//		super();
//		addKeyListener(this);
//		addActionListener(this);
//		addPropertyChangeListener(this);
//		addFocusListener(this);
//		
//	}
	
//	public NumberField(String defaulttext) {
//		super();
//		addKeyListener(this);
//		addActionListener(this);
//		addPropertyChangeListener(this);
//		addFocusListener(this);
//		this.defaulttext= defaulttext;
//		
//	}

    public NumberField( int size , String defaulttext ){
    	super(size);
    	
    	addKeyListener(this);
		addActionListener(this);
		addPropertyChangeListener(this);
		addFocusListener(this);
		this.defaulttext= defaulttext;
        ScriptEngineManager mgr = new ScriptEngineManager();
        engine = mgr.getEngineByName("JavaScript");
    	
        setActionCommand("NumberField");
    }
    
    
	public NumberField(String string,String defaulttext) {
		super(string.trim());
		addKeyListener(this);
		addActionListener(this);
		addPropertyChangeListener(this);
		addFocusListener(this);
		this.defaulttext= defaulttext;
		
        ScriptEngineManager mgr = new ScriptEngineManager();
        engine = mgr.getEngineByName("JavaScript");
		
        setActionCommand("NumberField");
	}
	
	
	
	
	/**
	  protected EventListenerList listenerList = new EventListenerList();

	  public void addDataChangeListener(NumberFieldDataChangeListener listener) {
	    listenerList.add(NumberFieldDataChangeListener.class, listener);
	  }
	  public void removeDataChangeListener(NumberFieldDataChangeListener listener) {
	    listenerList.remove(NumberFieldDataChangeListener.class, listener);
	  }
	  void fireDataChanged(NumberFieldDataChangeEvent evt) {
	    Object[] listeners = listenerList.getListenerList();
	    for (int i = 0; i < listeners.length; i = i+2) {
	      if (listeners[i] == NumberFieldDataChangeListener.class) {
	        ((NumberFieldDataChangeListener) listeners[i+1]).dataChange(evt);
	      }
	    }
	  }
	*/

	@Override  // enter key
	public void actionPerformed(ActionEvent actionevent) {

		if (!valid) {

			setText(oldText.replace(",", ".").trim());

			if (!checkValid(getText())) {

				setText(defaulttext);
			}
		}
		
		
		
	}

	@Override
	public void keyTyped(KeyEvent keyevent) {

	}

	@Override
	public void keyPressed(KeyEvent keyevent) {

		if (valid) {
			oldText = getText();
		}

	}

	@Override
	public void keyReleased(KeyEvent keyevent) {

		parseText();
	}

	@Override // manuell angeschubst in fr x/y fields in dicke/breite toolbar fr wechsel des knoten
	public void propertyChange(PropertyChangeEvent propertychangeevent) {

			parseText();
	}
	@Override
	public void focusGained(FocusEvent arg0) {
		
		
		selectAll();
		
	}

	@Override
	public void focusLost(FocusEvent arg0) {
	    parseText();
	    fireActionPerformed();
	}
	private void parseText( ){
		
		String input = getText();//.replace(",", ".").trim();
		
		
		
//		setText(input);
		
		if (checkValid(input)) {
			
			setBackground(Color.white);
			valid = true;
			
		

		} else {
			setBackground(Color.red);
			valid = false;
//			System.out.println("unvalid number: "+input);
			
		}
	}

	private boolean checkValid(String input) {
	    
		if(input.contains(",")){
			String replace = input.replace(",", ".");
			setText(replace);
			input=replace;
		}
		
		
		String output = input;
		String[] numbers = output.split("\\*|/|-|\\+");
		
		
		for (int i = 0; i < numbers.length; i++) {
		    
		    String[] t = numbers[i].split("\\.");
	        
	        if(t.length>2)return false;
            
		    if (numbers[i].contains("mm")) {
                String numS = numbers[i].replace("mm", "");
                double num = Double.parseDouble(numS);
                 String numUnit = ""+Unit.mmToUnit((float)num);
                 output=output.replace(numbers[i], numUnit);
//                 return false;
            }
	          if (numbers[i].contains("in")) {
	                String numS = numbers[i].replace("in", "");
	                double num = Double.parseDouble(numS);
	                 String numUnit = ""+Unit.inchToUnit((float)num);
	                 output=output.replace(numbers[i], numUnit);
//	                 return false;
	            }
        }
		
		if (output!=null) {
            setText(output);
            input=output;
        }
		
	    
	    boolean valide = output.matches("((\\*|/|-|\\+)?[0-9]+(\\.[0-9]+)?)+");
//	    String tt = new String(input);
//	    String[] t = tt.split("\\.");
//	    
//		if(t.length>2)valide=false;
		
		return valide;
	}
	
//	public String getText(){
//        return super.getText();
//	}
	/**returns unit value for text*/
	public double getUnit(){
	    actionPerformed(null);
	    evaluate();
	    return  Double.parseDouble(getText());
	}
	/**returns pt value for (unit) text*/
	public double getPt(){ 
	    actionPerformed(null);
	    evaluate();
	    return  Unit.pt(Double.parseDouble(getText()));
	}
	/**returns int value for text*/
	public int getIntValue(){
//	    actionPerformed(null);
//	    evaluate();
	    return (int) getValue();
	}
	   /**returns double value for text*/
    public double getValue(){
        actionPerformed(null);
        evaluate();
        return Double.parseDouble(getText());
    }
    public double getMM(){
        actionPerformed(null);
        return  Unit.mm(  getValue()  );
    }
    public void setSize(int width){
        int h=20;
        setPreferredSize(new Dimension(width  , h ));
        setMaximumSize(new Dimension(width  , h ));
        setMinimumSize(new Dimension(width  , h ));
    }
    
    private void evaluate(){
        
        // da vorher validiert wird und nur + und - (* / hinzugefgt)erlaubt sind, sollte das keine gefahr darstellen
        
        try {
            Object parsed = engine.eval(getText());
            
            if(parsed instanceof Number){
                
                if(maxValue!=null && ((Number) parsed).doubleValue() > maxValue.doubleValue()){
                    parsed=maxValue;
                }else if(minValue!=null && ((Number) parsed).doubleValue() < minValue.doubleValue()){
                    parsed=minValue;
                }
                setText(parsed+"");
            }
        } catch (ScriptException e) {
          e.printStackTrace();
        }
        
    }
    public Number getMaxValue() {
        return maxValue;
    }



    public void setMaxValue(Number maxValue) {
        this.maxValue = maxValue;
    }



    public Number getMinValue() {
        return minValue;
    }



    public void setMinValue(Number minValue) {
        this.minValue = minValue;
    }
    public void setText(String text){
        
       /**
        try {
          double old = Double.parseDouble(getText());
          double neu = Double.parseDouble(text);
          
          if(old != neu){
              fireDataChanged(new NumberFieldDataChangeEvent(null));
          }
        }catch (Exception e) {
       
        

        
             // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
        */
        super.setText(text);
        
        
    }

}
