package squircle;


import java.awt.Point;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import com.google.common.eventbus.EventBus;
import event.BasicEvent;
import event.squircleevt.*;


import processing.core.PApplet;
import processing.core.PConstants;

public class RulerView {

	private int rulerWidth;
	private PApplet papplet;
	private ZoomPan zp;
	
	private ArrayList<Helpline> helplines;
    private Helpline activeHelpline;
	
    private ArrayList<SliderThumb> sliderthumbs;
    private SliderThumb activeSliderthumb;
//    private EventBus eventBus;


    
	public RulerView(PApplet app, ZoomPan zp){
		
	    helplines = new ArrayList<RulerView.Helpline>();
	    sliderthumbs = new ArrayList<RulerView.SliderThumb>();
		rulerWidth=20;
		this.papplet=app;
		this.zp=zp;
		papplet.registerMouseEvent(this);

//		this.eventBus=eventBus;
		
		
	}
	
    public void initSlider(EventWidth ew, EventHeight eh, EventRadius er,
            EventSquirc es) {
        if (sliderthumbs.size() > 0)
            sliderthumbs.remove(0);
        
        SliderThumb s = new SliderThumb(papplet, SliderThumb.VERTICAL,
                eh);
        sliderthumbs.add(s);
        
        s = new SliderThumb(papplet, SliderThumb.HORIZONTAL, ew);
        sliderthumbs.add(s);
        
        s = new SliderThumb(papplet, SliderThumb.VERTICAL, er);
        sliderthumbs.add(s);
        
        s = new SliderThumb(papplet, SliderThumb.HORIZONTAL, es);
        sliderthumbs.add(s);
    }
	public void mDraw(){
		
		papplet.pushStyle();
		
		//ruler
		papplet.textSize(8);
		papplet.noStroke();
		papplet.fill(255, 255, 120);
//		papplet.rect(0, 0, rulerWidth, rulerWidth);
		papplet.rect(0, rulerWidth, rulerWidth, papplet.height);
		papplet.rect( rulerWidth,0, papplet.width, rulerWidth);
		
		// teilung
		papplet.stroke(0);papplet.fill(0);
		float start= zp.moveX;
		float part;
		boolean small;
		if(zp.zoomLevel<10){
			 part=(Unit.isMM)? Unit.pt(10f)*zp.zoom:Unit.pt(1f)*zp.zoom;
			 small=false;
		}else{
			 part=(Unit.isMM)? Unit.pt(1f)*zp.zoom:Unit.pt(0.1f)*zp.zoom;
			 small=true;
		}
		
		papplet.textAlign(PConstants.CENTER,PConstants.BOTTOM);
		// X positiv
		int l1=small?1001:101;
		for (float i = 0; i<l1; i++) {
			float cent;
			if (!small) {
				cent = (((int) i / 10) * 10 == i) ? 0.5f : 0.8f;
				if(cent==0.5f)papplet.text( (int)(i*((Unit.isMM)?10:1)), start, 8);
			}else{
				cent = (((int) i / 100) * 100 == i) ? 0.5f : 0.8f;
				if(cent==0.5f)papplet.text( (int)(i*((Unit.isMM)?1:0.1f)), start, 8);
			}
			
			papplet.line(start, rulerWidth*cent, start, rulerWidth);
			start+=part;
		}
//		papplet.textAlign(PConstants.LEFT,PConstants.CENTER);
		
		//X negativ
//		start= zp.moveX;
//		for (float i = 0; i < 100; i++) {
//			float cent=(((int)i/10)*10==i)?0.5f:0.8f;
//			papplet.line(start, rulerWidth*cent, start, rulerWidth);
//			start-=part;
//		}
		start= zp.moveY;
		papplet.textAlign(PConstants.LEFT,PConstants.CENTER);
		//Y positiv
		int l2=small?1001:101;
		for (float i = 0; i < l2; i++) {
			float cent;
			if (!small) {
				cent = (((int) i / 10) * 10 == i) ? 0.9f : 0.8f;
				if(cent==0.9f)papplet.text( (int)i*((Unit.isMM)?10:1), 0, start);
			}else{
				cent = (((int) i / 100) * 100 == i) ? 0.9f : 0.8f;
				if(cent==0.9f)papplet.text( (int)(i*((Unit.isMM)?1:0.1f)), 0, start);
			}
			
			papplet.line( rulerWidth*cent,start, rulerWidth, start);
			start+=part;
		}
		
		start= zp.moveY;
//		Y negativ
		int l3=small?501:51;
		for (float i = 0; i < l3; i++) {
			float cent;
			if (!small) {
				cent = (((int) i / 10) * 10 == i) ? 0.9f : 0.8f;
				if(cent==0.9f&&i>0)papplet.text("-"+ (int)i*((Unit.isMM)?10:1), 0, start);
			}else{
				cent = (((int) i / 100) * 100 == i) ? 0.9f : 0.8f;
				if(cent==0.9f&&i>0)papplet.text("-"+ (int)(i*((Unit.isMM)?1:0.1f)), 0, start);
			}
			
			papplet.line( rulerWidth*cent,start, rulerWidth, start);
			start-=part;
		}
		
		// mouse pos
		papplet.fill(255, 255, 120);papplet.noStroke();
		papplet.rectMode(PConstants.CENTER);
		papplet.rect(papplet.mouseX, 4, 40, 8);
		papplet.rect( 10.5f,papplet.mouseY, 21, 20);
		
		papplet.fill(0);
		papplet.textAlign(PConstants.CENTER,PConstants.BOTTOM);
		if (!small) {
			papplet.text(round(Unit.unitShort(zp.relMouseX),1), papplet.mouseX, 8);
		}else{
			papplet.text(round(Unit.unitShort(zp.relMouseX),100), papplet.mouseX, 8);
		}
		papplet.textAlign(PConstants.LEFT,PConstants.CENTER);
		if (!small) {
			papplet.text(round(Unit.unitShort(zp.relMouseY),1), 0, papplet.mouseY);
		}else{
			papplet.text(round(Unit.unitShort(zp.relMouseY),100),0, papplet.mouseY);
		}
		papplet.noFill();
		papplet.stroke(0);
		papplet.line(papplet.mouseX, rulerWidth+1, papplet.mouseX, rulerWidth);
		papplet.line(rulerWidth+2, papplet.mouseY, rulerWidth+1, papplet.mouseY);
		

		papplet.stroke(255, 255, 120);
		papplet.strokeWeight(1);
		papplet.fill(255, 255, 120);
		papplet.rectMode(PConstants.CORNER);
		papplet.rect(0, 0, rulerWidth+2, rulerWidth+2);
		
		for (Helpline hline : helplines) {
            hline.mDraw();
        }

		
		papplet.popStyle();
		
		
	}
	public void sliderDraw(){
			      for (SliderThumb thumb : sliderthumbs) {
	          thumb.mDraw();
	        }
	}
	private String round(float val, int stelle){
		
		float r = Math.round(val*stelle)/(float)stelle;
		
		return r+"";
	}
	


	   public void mouseEvent(MouseEvent e) {
	        // System.out.println(e.getButton());
	        try {
	            
//	            if(papplet.cursor())
	            switch (e.getID()) {
	            
	            case MouseEvent.MOUSE_RELEASED:
	                
	                if(activeHelpline !=null ){
	                    // aktive (gedraggt) loeschen
	                    if((activeHelpline.direction == Helpline.HORIZONTAL  && activeHelpline.getValue()*zp.zoom+zp.moveY < rulerWidth )||
	                       (activeHelpline.direction == Helpline.VERTICAL    && activeHelpline.getValue()*zp.zoom+zp.moveX < rulerWidth )
	                            ){
	                        helplines.remove(activeHelpline);
	                    }
	                    
	                }
	                // keine aktiv
	                activeHelpline = null;
	                break;
	                
	            case MouseEvent.MOUSE_CLICKED:
	                

	                break;
	            case MouseEvent.MOUSE_PRESSED:
	                //neue hilfslinie
	                if(e.getX() < rulerWidth && activeHelpline ==null){
	                    
	                    activeHelpline =  new Helpline(papplet, Helpline.VERTICAL);
	                    
	                    helplines.add(activeHelpline );
	                    
	                }else if( e.getY() < rulerWidth && activeHelpline ==null){

                        activeHelpline = new Helpline(papplet, Helpline.HORIZONTAL);
                        
	                    helplines.add( activeHelpline );
	                    
                    }else if(activeHelpline!=null && e.getButton()== MouseEvent.BUTTON3){
                        Point lc = papplet.getLocationOnScreen();
                        new HelplinePopup(activeHelpline, (float) (lc.getX()+papplet.mouseX), (float)( lc.getY()+papplet.mouseY));
                        activeHelpline=null;
                        
                    }
	                break;

	            case MouseEvent.MOUSE_DRAGGED:
	                try {
                        //aktive  verschieben
                          if(activeSliderthumb != null){
                               activeSliderthumb.drag();
                           }else if(activeHelpline !=null){
                               
                               activeHelpline.drag(e.getX()-zp.moveX,  (e.getY()-zp.moveY));
                           }
                           
                        
                    } catch (Exception e1) {
                        // TODO Auto-generated catch block
                        e1.printStackTrace();
                    }
	                   
	                break;
	            case MouseEvent.MOUSE_MOVED:
	                try {
                        // hilfslinie draggen?
                        checkActiveSliderthumb(e);
                        
                        checkActiveHelpline(e);
                    } catch (Exception e1) {
                        // TODO Auto-generated catch block
                        e1.printStackTrace();
                    }
                   
	                break;
	            default:
	                break;
	            }
	            papplet.redraw();
	        } catch (Exception e1) {
//	            BowLog.getLogger().log(Level.SEVERE,"Ruler:mouseEvent ERROR",e);
	        }
	    }
	   
	   
	   
    private void checkActiveHelpline(MouseEvent e) {
        
        papplet.getCursor().getName();
        
        for (Helpline h : helplines) {
            
            if ((h.direction == Helpline.VERTICAL && insideTolerance(h.getValue() * zp.zoom, (e.getX() - zp.moveX)))
                    || (h.direction == Helpline.HORIZONTAL && insideTolerance(h.getValue() * zp.zoom, (e.getY() - zp.moveY)))) {
                
                activeHelpline = h;
                return;
            }
        }
        activeHelpline = null;
        
    }
    
    private void checkActiveSliderthumb(MouseEvent e) {
        
        try {
            
            Vect2 mouse = new Vect2(e.getX(), e.getY());
            
            for (SliderThumb h : sliderthumbs) {
                
                Vect2 thumb = new Vect2();
                
                if(h.direction==Helpline.HORIZONTAL){
                    thumb.x=(h.event.getPos().x)*zp.zoom+zp.moveX;
                    thumb.y=(h.event.getPos().y)*zp.zoom+zp.moveY;
                }else{
                    thumb.x=(h.event.getPos().x)*zp.zoom+zp.moveX;
                    thumb.y=(h.event.getPos().y)*zp.zoom+zp.moveY;
                }
                
                if (mouse.distance(thumb)<h.size/2*zp.zoom) {
                    
                    activeSliderthumb = h;
                    return;
                }
            }
        } catch (Exception e1) {
//            BowLog.getLogger().log(Level.SEVERE,"Ruler:checkActiveSliderthumb",e1);
        }
        activeSliderthumb = null;
        
    }
    

    
    private boolean insideTolerance(float a, float b) {
        float t = 10;
        if (Math.max(a, b) - Math.min(a, b) < t)
            return true;
        
        return false;
    }


    public class Helpline{
	       
	       public static final int HORIZONTAL = 0;
	       public static final int VERTICAL = 1;
	       private int direction;
	       private PApplet g;
	       private float value=0;
	       private float stroke=0.5f;
	       
	       public Helpline(PApplet drawingcontext, int direction){
	           
	           this.direction = direction;
	           g = drawingcontext;
	       }
	       
	       public void drag(float f, float h){
	           
	           g.getCursor().getName();
	           
	           if(direction == HORIZONTAL){
	               value =  (h / zp.zoom);
	           }else if(direction==VERTICAL){
	               value= (f/zp.zoom);
	           }
	       }
	       
	       public boolean mDraw(){
	           
//	           if(value ==0){
//	               return false;
//	           }
	           
	           g.pushStyle();
	           g.noFill();
	           if(activeHelpline == this){
	               g.stroke(0, 180, 255);
	           }else{
	                g.stroke(0, 0, 255);
	           }
	          
	           g.strokeWeight(stroke);
	           
               if(direction == HORIZONTAL){
                   g.line(0, value*zp.zoom+zp.moveY, g.width, value*zp.zoom+zp.moveY);
               }else if(direction==VERTICAL){
                  g.line(value*zp.zoom+zp.moveX, 0, value*zp.zoom+zp.moveX, g.height);
               }
               
               g.popStyle();
               
               return true;
	       }

        public float getValue() {
            return value;
        }

        public void setValue(float value) {
            this.value = value;
        }
	       
	       
	   }
    
    public class SliderThumb{
    	
        public static final int HORIZONTAL = 0;
        public static final int VERTICAL = 1;
        private int direction;
        private PApplet g;
        private float stroke=2f;
        private int size=15;
        private BasicEvent event;
        
        
        
        public SliderThumb(PApplet drawingcontext, int direction, BasicEvent evt){
            
            this.direction = direction;
            g = drawingcontext;
            this.event=evt;

        }
        
        public void drag() {
            
            float val = event.getValue();
            
            if (direction == HORIZONTAL) {
                
                event.setRequestValue(val + (g.mouseX - g.pmouseX)/zp.zoom);
                
            } else {// if (direction == VERTICAL)
            
                event.setRequestValue(val + ((g.mouseY - g.pmouseY)/zp.zoom));
                
            }
            Ebus.get().post(event);
            
            if (!event.isSuccess()) {
//                activeSliderthumb = null;
            }
        }
        
        public boolean mDraw() {
            
            
            g.pushStyle();
            
            if (activeSliderthumb == this) {
                papplet.fill(255, 255, 120, 150);
                papplet.stroke(0, 150);
            } else {
                papplet.fill(255, 255, 120, 255);
                papplet.stroke(0, 255);
            }
            
            g.strokeWeight(stroke);
            
            Vect2 vect = event.getPos();
            
            
            if (direction == HORIZONTAL) {
                
                g.ellipseMode(PConstants.CENTER);
                g.ellipse(vect.x , vect.y , size, size);
                
            } else  {//if (direction == VERTICAL)
                
                g.ellipseMode(PConstants.CENTER);
                g.ellipse(vect.x , vect.y , size, size);
            }
            g.noStroke();
            g.fill(255, 120, 255);
            g.textAlign(PConstants.LEFT);
            g.textSize(12);
            
            g.popStyle();
            
            return true;
        }
        
        
    }

	
}
