package squircle;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.GeneralPath;
import com.google.common.eventbus.Subscribe;
import event.squircleevt.*;
import processing.core.PApplet;


public class Squircle {
    
    float posX=0;
    float posY=0;
    DataObject width;
    DataObject height;
    DataObject radius;
    DataObject sqirc;
    Bezier c1= new Bezier();
    Bezier c2= new Bezier();
    Bezier c3= new Bezier();
    Bezier c4= new Bezier();
    private float maxRadius;
    Vect2 w;
    Vect2 h;
    
    public Squircle( EventWidth ew, EventHeight eh, EventRadius er, EventSquirc es) {
        
        
        width = ew;
        height= eh;
        radius=er;
        sqirc=es;
        
        maxRadius = width.getValue() <= height.getValue() ? width.getValue() / 2f
                : height.getValue() / 2f;
        
        set();
    }
    

    @Subscribe (priority=1)
    public void setWidth(EventWidth ew) {
        
        float nw = ( width.getRequestValue()-width.getValue() )*2f +width.getValue();
        
        if (nw < 10) {
            ew.setSuccess(false);
            return;
        }
        
        width.setValue(nw);
        maxRadius = width.getValue() <= height.getValue() ? width.getValue() / 2f
                : height.getValue() / 2f;
        
        if (radius.getValue() > maxRadius) {
            radius.setValue(maxRadius);
            
        }

        if (sqirc.getValue() > radius.getValue() - (radius.getValue() / 1.826f)) {
            
            sqirc.setValue(radius.getValue() - (radius.getValue() / 1.826f));
            
        }
        set();
        ew.setSuccess(true);
    }
    
    
    @Subscribe (priority=1)
    public void setHeight(EventHeight eh){
        
        float nh = ( height.getRequestValue()-height.getValue() )*2f +height.getValue();
        
        if(nh<10){
           eh.setSuccess(false);
            return;
        }
        
         height.setValue(nh);
         maxRadius = width.getValue() <= height.getValue() ? width.getValue() / 2f : height.getValue() / 2f;
         
         if (radius.getValue() > maxRadius) {
             radius.setValue(maxRadius);
         }

         if (sqirc.getValue() > radius.getValue() - (radius.getValue() / 1.826f)) {
             
             sqirc.setValue(radius.getValue() - (radius.getValue() / 1.826f));
             
         }
         set();
         eh.setSuccess(true);
    }
    
    
    
    
    
    @Subscribe(priority = 1)
    public void setSquirc(EventSquirc es) {
        
        
        if (es.getRequestValue() < 0 || es.getRequestValue() > radius.getValue()
                - (radius.getValue() / 1.826f)) {
            
          es.setSuccess(false);
          return;
      }
        
        sqirc.setValue(es.getRequestValue());
        set();
        es.setSuccess(true);
    }
    
    
    
    
    
    
    @Subscribe(priority = 1)
    public void setRadius(EventRadius er) {
        
        if (er.getRequestValue() < 0 || er.getRequestValue() > maxRadius) {
            er.setSuccess(false);
            return;
            
        }
        radius.setValue(er.getRequestValue());
        
        if (sqirc.getValue() > radius.getValue() - (radius.getValue() / 1.826f)) {
            
            sqirc.setValue(radius.getValue() - (radius.getValue() / 1.826f));
            
        }
        set();
        er.setSuccess(true);
    }
    
    
    
    
    
    
    public void set(){
        
        // ecke links oben
        float y= posY - height.getValue()/2f ;
        float x=  posX - width.getValue()/2f;
        
        c1.start.x= x;
        c1.start.y= y +  radius.getValue();
        c1.pt1.x = x;     
        c1.pt1.y = y + sqirc.getValue();
        c1.pt2.x = x + sqirc.getValue() ;
        c1.pt2.y = y;
        c1.an.x = x +  radius.getValue();
        c1.an.y = y;
        
        // rechts oben
        x= posX + width.getValue()/2f;
        
        c2.start.x= x -radius.getValue();
        c2.start.y= y ;
        c2.pt1.x = x - sqirc.getValue();     
        c2.pt1.y = y ;
        c2.pt2.x = x  ;
        c2.pt2.y = y + sqirc.getValue();
        c2.an.x = x ;
        c2.an.y = y +  radius.getValue();
        
        // rechts unten
        y= posY + height.getValue()/2f ;
        
        c3.start.x= x;
        c3.start.y= y -  radius.getValue();
        c3.pt1.x = x;     
        c3.pt1.y = y - sqirc.getValue();
        c3.pt2.x = x  - sqirc.getValue();
        c3.pt2.y = y ;
        c3.an.x = x -  radius.getValue();
        c3.an.y = y;
        
        // links unten
        x=  posX - width.getValue()/2f;

        c4.start.x= x +radius.getValue();
        c4.start.y= y ;
        c4.pt1.x = x + sqirc.getValue();     
        c4.pt1.y = y ;
        c4.pt2.x = x  ;
        c4.pt2.y = y - sqirc.getValue();
        c4.an.x = x ;
        c4.an.y = y -  radius.getValue();
        
        try {
            width.setPosition(c2.an.lerped( c3.start, 0.5f));
            height.setPosition(c3.an.lerped(c4.start, 0.5f));
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }


    }
    
    public void draw(PApplet app, Graphics2D cg, boolean record){
        
        app.beginShape();
        app.vertex(c1.start.x, c1.start.y);
        c1.draw(app);
        app.vertex( c2.start.x, c2.start.y);
        c2.draw(app);
        app.vertex( c3.start.x, c3.start.y);
        c3.draw(app);
        app.vertex( c4.start.x, c4.start.y);
        c4.draw(app);
        app.vertex( c1.start.x, c1.start.y);
        app.endShape();
        
        
        
        if(record){
            cg.setColor(Color.RED);
            GeneralPath path = new GeneralPath();
            path.moveTo(c1.start.x, c1.start.y);
            path.curveTo(c1.pt1.x,c1.pt1.y,c1.pt2.x,c1.pt2.y, c1.an.x,c1.an.y);
            path.lineTo( c2.start.x, c2.start.y);
            path.curveTo(c2.pt1.x,c2.pt1.y,c2.pt2.x,c2.pt2.y, c2.an.x,c2.an.y);
            path.lineTo( c3.start.x, c3.start.y);
            path.curveTo(c3.pt1.x,c3.pt1.y,c3.pt2.x,c3.pt2.y, c3.an.x,c3.an.y);
            path.lineTo( c4.start.x, c4.start.y);
            path.curveTo(c4.pt1.x,c4.pt1.y,c4.pt2.x,c4.pt2.y, c4.an.x,c4.an.y);
            path.closePath();
            cg.fill(path);
            cg.draw(path);
        }
  
    }
    
    
    class Bezier {
        
        Vect2 start = new Vect2();
        Vect2 pt1   = new Vect2();
        Vect2 pt2   = new Vect2();
        Vect2 an    = new Vect2();
        
        public Bezier() {
            
        }
        
        public void draw(PApplet app) {
            // app.stroke(Color.black.getRGB());
            app.bezierVertex(pt1.x, pt1.y, pt2.x, pt2.y, an.x, an.y);
            
        }
        
    }
    
    
    
}
