package squircle;


/**
 * The Class Unit.
 */
public class Unit {
	
	/** The def. */
	private static double def= (72./25.4);
	
	/** The mm. */
	private static double mm= (72./25.4);
	
	/** The in. */
	private static double in= 72.;
	
	private static double scale = 100.;
	public static boolean isMM=true;
	
	public static final double nmmTOlbsin = 145.037738;

	/**
	 * Sets the default to mm
	 */
	public static void setDefaultMM(){
		def=mm;
		scale = 100;
		isMM=true;
	}
	
	/**
	 * Sets the default to Inch
	 */
	public static void setDefaultIN(){
		def=in;
		scale=1000;
		isMM=false;
	}
	
	/**
	 * @return unit(mm/inch) float
	 */
	public static float unitShort(float pt){
		return (float) (((int)(pt/def*scale))/scale);
//		return pt/def;
	}
	
	/**
	 * @return pt float
	 */
	public static float pt(float unit){
		return (float) (unit*def);
	}
	
	/**
	 * @return unit(mm/inch) double
	 */
	public static double unitPrecise(double pt){
		return ((pt/def*scale))/scale;
		
	}
	
	/**
	 * @return pt double
	 */
	public static double pt(double unit){
		return unit*def;
	}
	
	/**
	 * @return unit(mm/inch) int  !!!!!!!!!!!
	 */
	public static int unit(int pt){
		return (int) (pt/def);
	}
	
	/**
	 * @return pt int  !!!!!!!!!!!
	 */
	public static int pt(int unit){
		return (int) (unit*def);
	}
	/**
	 * @return unit text String
	 */
	public static String unitText(){
		return isMM?" mm":" inch";
	}
	/**
	 * @return unit double
	 */
	public static double mmToUnit(double si_mm){
		return  isMM? si_mm:si_mm/25.4d;
	}
	/**
	 * @return unit double
	 */
	public static float mmToUnit(float si_mm){
		return  isMM? si_mm:si_mm/25.4f;
	}
	   /**
     * @return unit double
     */
    public static double inchToUnit(double inch){
        return  !isMM? inch:inch*25.4d;
    }
    /**
     * @return unit double
     */
    public static float inchToUnit(float inch){
        return  !isMM? inch:inch*25.4f;
    }
	/**
	 * @return mm double
	 */
	public static double mm(double unit){
		return  isMM? unit:unit*25.4d;
	}
	/**
	 * @return mm double
	 */
	public static float mm(float unit){
		return  isMM? unit:unit*25.4f;
	}
	/**isMM?" N/mm":"lbf/in"*/
	public static String stressText() {
		
		return isMM?" N/mm\u00B2":" lbf/in\u00B2";
	}
	
	/**isMM?" N/mm":"lbf/in"*/
	public static float unitStress(float SI_stress){

		return isMM? SI_stress : (float)(SI_stress *  nmmTOlbsin);
		
	}
	/**isMM?" N/mm":"lbf/in"*/
	public static float siStress(float UNIT_stress){

		return isMM? UNIT_stress : (float)(UNIT_stress /  nmmTOlbsin);
		
	}

    public static double mmToPt(double mm) {
        
       return mm/25.4d*72d;
    }

	public static float radToDeg(double angle) {
		
			return  (float) (2 * Math.PI / 360 * angle);
		

	}
//	/** arg: gramm    returns Newton*/
//    public static double grToForce(double gramm) {
//        
//        return gramm/10.1972;
//    }
//    public static double forceToGr(double Newton) {
//        
//        return Newton*10.1972;
//    }
 public static double forceToKG(double Newton) {
        
        return Newton/9.80665;
    }
 public static double kgToForce(double kg) {
     
     return kg*9.80665;
 }
 public static double forceToLB(double Newton) {
     
     return Newton/4.4482216152605;
 }
public static double lbToForce(double lbf) {
  
  return lbf*4.4482216152605;
}


public static void main(String[] args) {
    
    System.out.println(            forceToKG(1)               );
    System.out.println(            forceToLB(1)               );
    
}


}
