package squircle;



import processing.core.PApplet;



public class ZoomPan  {


    /** The x translation */
	public float moveX;
	/** The y translation */
	public float moveY;
	public float zoom;
	/** The relative mouse x. */
	public float relMouseX;
	/** The relative mouse y. */
	public float relMouseY;
	private float zoomStep;
	float zoomLevel;
	private int maxIn=10;
	private int maxOut=-5;
	private float initZoom;
	public Vect2 relMouse=new Vect2();


	public ZoomPan(float initZoom) {
		moveX = 0;
		moveY = 0;
		this.initZoom=initZoom;
		zoom = initZoom;
		zoomLevel = 0;
//		app.width = w;
//		app.height = h;
		relMouseX = 0;
		relMouseY = 0;
		zoomStep = 1.25f;
		

	}

	public void targetZoomIn(int mx, int my) {
		if (zoomLevel > maxIn) {
			return;
		}

		zoomLevel++;
		zoom *= zoomStep;
		moveX *= zoomStep;
		moveY *= zoomStep;
		moveX -= mx * zoomStep - mx;
		moveY -= my * zoomStep - my;
//		System.out.println("zoom: "+zoomLevel);

	}

	public void targetZoomOut(int mx, int my) {
		if (zoomLevel < maxOut) {

			return;
		}
		zoom *= 1 / zoomStep;
		zoomLevel--;
		moveX *= 1 / zoomStep;
		moveY *= 1 / zoomStep;
		moveX += (mx - mx / zoomStep);
		moveY += (my - my / zoomStep);
	}

	public void centerZoomIn(PApplet app) {

		if (zoomLevel > maxIn) {
			return;
		}

		zoomLevel++;
		zoom *= zoomStep;
		moveX *= zoomStep;
		moveY *= zoomStep;
		moveX -= app.width / 2 * zoomStep - app.width / 2;
		moveY -= app.height / 2 * zoomStep - app.height / 2;

	}

	public void centerZoomOut(PApplet app) {

		if (zoomLevel <= maxOut) {
			// zoom=0.5f;
			// zoomLevel=0;

			return;
		}
		zoom *= 1 / zoomStep;
		zoomLevel--;
		moveX *= 1 / zoomStep;
		moveY *= 1 / zoomStep;
		moveX += (app.width / 2 - app.width / 2 / zoomStep);
		moveY += (app.height / 2 - app.height / 2 / zoomStep);
	}
	public void resetZoom(PApplet app){
		moveX = app.width / 8;
		moveY = app.height / 2;
		zoom=initZoom;
	}

	public void setMinZoom(int i) {
		maxOut=i;
		
	}

	public void updateMousePosition(PApplet app) {
        relMouseX = (app.mouseX - moveX) / zoom;
        relMouseY = (app.mouseY - moveY) / zoom;
		relMouse.set(relMouseX,relMouseY);
	}

	public void pan(PApplet app) {
        moveX +=  (app.mouseX - app.pmouseX);
        moveY +=  (app.mouseY - app.pmouseY);
		
	}
	
	

}
